routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



//Auth::routes(['verify' => false,'register' => false]);

Route::get('/', function(){
	return redirect('login');
})->where(['url' => '|home'])->name('home');

if(env('API_URL')=="" || env('API_URL')==url('/')){
	Auth::routes(['register'=>false]);
	Route::get('index', 'HomeController@index')->name('index');
}

Route::group(['middleware' => ['frontend']], function(){	
	Route::get('/{url?}', 'HomeController@index')->where(['url' => '|home'])->name('home');
});

Route::group(['middleware' => ['auth']], function(){
	Route::get('access-denied', function(){
		return view('access-denied');
	})->name('access-denied');
        Route::resource('profile', 'ProfileController')->only(['index', 'store']);
		Route::group(['middleware' => ['check_permission'],'namespace'=>'Admin','prefix'=>'admin', 'as' => 'admin.'], function(){	

		Route::get('dashboard', 'DashboardController@index')->name('dashboard');
		Route::resource('profile', 'ProfileController')->only(['index', 'store']);
        Route::resource('settings', 'SettingsController')->only(['index', 'store']);

		// For Users
		Route::resources([
			'users' => 'UsersController',
		]);
		
        Route::post('users/getUsers', 'UsersController@getUsers')->name('users.getUsers');
		Route::get('users/status/{user_id}', 'UsersController@status')->name('users.status');	

       // For complainttype
		Route::resource('complainttype', 'ComplaintTypeController')->except(['show']);
		Route::post('complainttype/list', 'ComplaintTypeController@getComplaintType')->name('complainttype.getComplaintType');
		Route::get('complainttype/status/{id}', 'ComplaintTypeController@status')->name('complainttype.status');	

         // For roles
		Route::resource('roles','RoleController');
		Route::get('roles/destroy/{id}', 'RoleController@destroy')->name('roles.destroy');
		Route::get('roles/status/{id}', 'RoleController@status')->name('roles.status');
	
        // For Complaints
		Route::resource('complaints', 'ComplaintsController');
		Route::post('complaints/list', 'ComplaintsController@getComplaints')->name('complaints.getComplaints');
		Route::get('complaints/status/{id}', 'ComplaintsController@status')->name('complaints.status');
		Route::get('complaints/aprovelstatus/{id}', 'ComplaintsController@aprovelStatus')->name('complaints.aprovelstatus');	
		Route::get('complaints/rejectstatus/{id}', 'ComplaintsController@rejectStatus')->name('complaints.rejectStatus');	


		Route::resource('components','ComponentController');
    	Route::get('components/destroy/{id}', 'ComponentController@destroy')->name('components.destroy');
    	Route::get('components/status/{id}', 'ComponentController@status')->name('components.status');

    	Route::resource('vehicles','VehiclesController');
    	Route::post('vehicles/getVehicles', 'VehiclesController@getVehicles')->name('vehicles.getVehicles');
    	Route::get('vehicles/status/{id}', 'VehiclesController@status')->name('vehicles.status');

	});

});

app/Http/Controllers/API/ComplaintTypeController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\ComplaintType;

class ComplaintTypeController extends Controller
{
   function getComplaintType(){
try{
    $complainttype=ComplaintType::where('is_active',true)->get();
    if(!empty($complainttype)){
        $response['status'] = 200;
        $response['data'] = $complainttype;
        $response['message'] = "Success";
        return response()->json($response);
    }
    else{
        $response['status'] = 204;
        $response['data'] = [];
        $response['message'] = "Success";
        return response()->json($response);

    }
}catch (\Exception $e) {
    $response['status'] = 500;
    $response['message'] = $e->getMessage();
    return response()->json($response);
}
   }
}

app/Http/Controllers/Admin/ComplaintTypeController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DataTables;
use Form;
use App\ComplaintType;
use File;

class ComplaintTypeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.complainttype.index');
    }

      /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function getComplaintType(Request $request){
        $complainttype = ComplaintType::query(); 
        $complainttype->select([\DB::raw(with(new ComplaintType)->getTable().'.*')])->groupBy('id');          

        return DataTables::of($complainttype)               
            ->editColumn('is_active', function ($complainttype){
                if($complainttype->is_active == TRUE ){
                    return "<a href='".route('admin.complainttype.status',$complainttype->id)."'><span class='badge badge-success'>Active</span></a>";
                }else{
                    return "<a href='".route('admin.complainttype.status',$complainttype->id)."'><span class='badge badge-danger'>Inactive</span></a>";
                }
            })
            ->editColumn('image', function ($complainttype){
                $url=url('/uploads/setting',$complainttype->image);
                return '<img src="'.$url.'"/>';
            })   

            ->addColumn('action', function ($complainttype) {
                return
                    // edit
                    '<a href="'.route('admin.complainttype.edit',[$complainttype->id]).'" class="btn btn-success btn-circle btn-sm"><i class="fas fa-edit"></i></a> '.
                    // Delete
                    Form::open(array(
                        'style' => 'display: inline-block;',
                        'method' => 'DELETE',
                        'onsubmit'=>"return confirm('Do you really want to delete?')",
                        'route' => ['admin.complainttype.destroy', $complainttype->id])).
                    ' <button type="submit" class="btn btn-danger btn-circle btn-sm"><i class="fas fa-trash"></i></button>'.
                    Form::close();
            })
            ->rawColumns(['media.name','is_active','action','image'])
            ->make(true);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.complainttype.form');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // $ComplaintType = ComplaintType::get();
        $rules = [
            'title'=>'required|unique:'.with(new ComplaintType)->getTable(),
            'image'=>'file|mimes:jpeg,png,jpg',
        ];
        $request->validate($rules);
        $data = $request->all();
        $type_image = $request->file('image');
        if($type_image){
            $path = public_path(config('constants.SETTING_IMAGE_URL'));
            $type_imageName = time().'.'.$type_image->getClientOriginalExtension();
            File::isDirectory($path) or File::makeDirectory($path, 0777, true, true);
            $uploadResponse = $type_image->move($path, $type_imageName);
            $data['image'] = $type_imageName;
        }
        $type=ComplaintType::create($data);
        $request->session()->flash('success',__('global.messages.add'));
        return redirect()->route('admin.complainttype.index');
    }
    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($complainttype_id)
    {
        $complainttype = ComplaintType::findOrFail($complainttype_id);
        return view('admin.complainttype.form',compact('complainttype'));
    }
    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Complainttype $Complainttype)
    {
        $rules = [            
            'title'=>'required|unique:'.with(new ComplaintType)->getTable().',title,'.$Complainttype->getKey(),
            'image'=>'file|mimes:jpeg,png,jpg',
        ];
        $request->validate($rules);
        $data = $request->all();
        $type_image = $request->file('image');
        if($type_image){
            $path = public_path(config('constants.SETTING_IMAGE_URL'));
            $type_imageName = time().'.'.$type_image->getClientOriginalExtension();
            File::isDirectory($path) or File::makeDirectory($path, 0777, true, true);
            $uploadResponse = $type_image->move($path, $type_imageName);
            $data['image'] = $type_imageName;
        }
        $Complainttype->update($data);   
        $request->session()->flash('success',__('global.messages.update'));
        return redirect()->route('admin.complainttype.index');
    }

    /**
     * Change status the specified resource from storage.
     *
     * @return \Illuminate\Http\Response
    */
    public function status(Request $request, $country_id=null){
        $country = ComplaintType::findOrFail($country_id);
        if (isset($country->is_active) && $country->is_active==FALSE) {
            $country->update(['is_active'=>TRUE]);
            $request->session()->flash('success',__('global.messages.activate'));
        }else{
            $country->update(['is_active'=>FALSE]);
            $request->session()->flash('danger',__('global.messages.deactivate'));
        }
        return redirect()->route('admin.complainttype.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
     public function destroy(Request $request,Complainttype $Complainttype)
     {
            $Complainttype->delete();
            $request->session()->flash('danger',__('global.messages.delete'));
            return redirect()->route('admin.complainttype.index');
     }
}

resources/views/admin/complainttype/form.blade.php
@extends('admin.layouts.valex_app')
@section('content')
<div class="container">
    <!-- Page Heading -->
    <div class="breadcrumb-header justify-content-between">
        <div class="left-content">
            <div>
              <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Market Survey</h2>
            </div>
        </div>
    </div>
    <div class="row row-sm">
        <div class="col-xl-12">
            <div class="card">
                {!! Form::open(['method' => 'POST', 'route' => isset($complainttype->id)?['admin.complainttype.update',$complainttype->id]:['admin.complainttype.store'],'class' => 'form-horizontal','id' => 'frmCountry', 'files' => true]) !!}
                @csrf
                @if(isset($complainttype->id))
                @method('PUT')
                @endif
                <div class="card-header py-3 cstm_hdr">
                    <h6 class="m-0 font-weight-bold text-primary">{{ isset($complainttype->id)?'Edit':'Add' }} Type</h6>
                </div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <div class="col-md-12 form-group {{$errors->has('title') ? config('constants.ERROR_FORM_GROUP_CLASS') : ''}}">
                                <label for="title">Title <span style="color:red">*</span></label>
                                {!! Form::text('title', old('title', isset($complainttype->title)?$complainttype->title:''), ['id'=>'title', 'class' => 'form-control', 'placeholder' => 'Title']) !!}

                                @if($errors->has('title'))
                                <p class="help-block">
                                    <strong>{{ $errors->first('title') }}</strong>
                                </p>
                                @endif
                            </div>                    
                                             
                        </div>
                    </div>
                    <div class="row">
                    <div class="col-4">
                    
                    @if(isset($complainttype->image) && $complainttype->image!='' && url('/uploads/setting',$complainttype->image)) 
                    <div class="form-group">
                        <div class="col-md-12">
                            <img id="blah" width="100" height="100" src="{{url('/uploads/setting',$complainttype->image)}}">
                        </div>
                    </div>
                    @else
                    <div class="form-group">
                        <div class="col-md-12">
                            <img id="blah" width="100" height="100" src="{{url('/images/no_image.png')}}">
                        </div>
                    </div>
                    @endif

                    <div class="form-group {{$errors->has('image') ? config('constants.ERROR_FORM_GROUP_CLASS') : ''}}">
                        <label class="col-md-8" for="title">Complaint type image</label>
                        <div class="col-md-8">
                        <input type="file" name="image" onchange="document.getElementById('blah').src = window.URL.createObjectURL(this.files[0])">
                            @if($errors->has('image'))
                            <strong for="image" class="help-block">{{ $errors->first('image') }}</strong>
                            @endif
                        </div>
                    </div>
                </div>
                    
                    </div>
                </div>  
                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Submit</button>
                    <a href="{{route('admin.complainttype.index')}}"  class="btn btn-secondary">Cancel</a>
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection
@section('scripts')
<script type="text/javascript" src="{{ asset('js/jquery-validation/dist/jquery.validate.min.js') }}"></script>
<script type="text/javascript">
jQuery(document).ready(function(){
    jQuery('#frmCountry').validate({
        rules: {
            title: {
                required: true
            }          
        }
    });
});
</script>
@endsection

resources/views/admin/complainttype/index.blade.php
@extends('admin.layouts.valex_app')
@section('styles')
<link href="{{asset('template/valex-theme/plugins/datatable/css/dataTables.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/buttons.bootstrap4.min.css')}}" rel="stylesheet">
<link href="{{asset('template/valex-theme/plugins/datatable/css/jquery.dataTables.min.css')}}" rel="stylesheet">
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.dataTables.min.css')}}" rel="stylesheet">
@endsection

@section('content')
<!-- Begin Page Content -->
<div class="container">
  <div class="breadcrumb-header justify-content-between">
      <div class="left-content">
          <div>
            <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Complaint Types</h2>
          </div>
      </div>
  </div>
  <div class="row row-sm">
    <div class="col-xl-12">
      <div class="card">
        <div class="card-header py-3 cstm_hdr">
             <h6 class="m-0 font-weight-bold text-primary">Complaint Types</h6>
            <a href="{{route('admin.complainttype.create')}}" class="btn btn-sm btn-icon-split float-right btn-outline-warning">
                <span class="icon text-white-50">
                  <i class="fas fa-plus"></i>
                </span>
                <span class="text">Add Type</span>
            </a>
           
        </div>
        <div class="card-body">
            <div class="table-responsive">
                <table class="table table-bordered" width="100%" cellspacing="0" id="countries">
                    <thead>
                        <tr>
                            <th>Title</th>
                            <th>Image</th>
                            <th>Status</th>     
                            <th>Action</th>                      
                        </tr>
                    </thead>
                    <tfoot>
                        <tr>
                            <th>Title</th>
                            <th>Image</th>
                            <th>Status</th>     
                            <th>Action</th>                  
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div>
      </div>
    </div>
  </div>
</div>    
<!-- /.container-fluid -->
@endsection

@section('scripts')
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.bootstrap4.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.bootstrap4.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/vfs_fonts.js') }}"></script>
<!-- export btn -->
<script type="text/javascript">
     
    jQuery(document).ready(function(){
        getCountries();
    });
    function getCountries(){        
        
        jQuery('#countries').dataTable().fnDestroy();
        jQuery('#countries tbody').empty();
        var table=jQuery('#countries').DataTable({
            processing: true,
            serverSide: true,
            iDisplayLength:50,
            ajax: {
                url: '{{ route('admin.complainttype.getComplaintType') }}',
                method: 'POST',
                data: {     
                }
            },
            lengthMenu: [
                [10, 25, 50, 100, -1],
                [10, 25, 50,100,"All"]
            ],
            columns:[              
                {data: 'title', name: 'title'}, 
                {data: 'image', name: 'image', class: 'text-center', "width": "10%"},             
                {data: 'is_active', name: 'is_active', class: 'text-center', "width": "10%"},             
                {data: 'action', name: 'action', orderable: false, searchable: false, "width": "15%"}    
            ],           
            order: [[0, 'asc']], 
            language:{
                searchPlaceholder: 'Search...',
                sSearch: '',
                lengthMenu: '_MENU_',
            },  
        }); 
    
    }      
</script>
@endsection